﻿Class WizardStart
    Private WithEvents m_Page1 As WizardPage1

    ' Display page 1.
    Private Sub btnPage1_Click() Handles btnPage1.Click
        m_Page1 = New WizardPage1(New WizardData)
        NavigationService.Navigate(m_Page1)
    End Sub

    ' Page 1 returned.
    Private Sub m_Page1_Return(ByVal sender As Object, ByVal e As System.Windows.Navigation.ReturnEventArgs(Of WizardData)) Handles m_Page1.Return
        Dim wiz_data As WizardData = e.Result

        ' See if the user canceled.
        If wiz_data.Canceled Then
            lblAppetizer.Content = ""
            lblEntree.Content = ""
            lblSalad.Content = ""
            lblDrink.Content = ""
            lblDessert.Content = ""
        Else
            lblAppetizer.Content = wiz_data.Appetizer
            lblEntree.Content = wiz_data.Entree
            lblSalad.Content = wiz_data.Salad.ToString
            lblDrink.Content = wiz_data.Drink
            lblDessert.Content = wiz_data.Dessert.ToString
        End If
    End Sub
End Class
