﻿'Option Strict On

Public Class Form1
    ' Declare the delegate type.
    Private Delegate Sub TestDelegate(ByVal ctl As Control)

    ' A more general parameter type.
    Private Sub Test1(ByVal obj As Object)
        obj.Text = "Test1"    ' Needs Option Strict off.
    End Sub

    ' A more specific parameter type.
    Private Sub Test2(ByVal text_box As TextBox)
        text_box.Text = "Test2"
    End Sub

    ' Parameter omitted.
    Private Sub Test3()
        txtField3.Text = "Test3"
    End Sub

    ' Make variables of the delegate type
    ' hold references to the subroutines.
    Private Sub1 As TestDelegate = AddressOf Test1
    Private Sub2 As TestDelegate = AddressOf Test2 ' Needs Option Strict off.
    Private Sub3 As TestDelegate = AddressOf Test3

    ' Use the variables to call the test routines.
    Private Sub Form1_Load() Handles MyBase.Load
        Sub1(txtField1)
        Sub2(txtField2)
        Sub3(Nothing)
        'Test3(txtField3)  ' This doesn't work.
    End Sub
End Class
