﻿Public Class Form1
    ' Create the queue.
    Private m_Queue As New Queue

    ' Add an item to the queue.
    Private Sub btnAdd1_Click() Handles btnAdd1.Click
        m_Queue.Enqueue(txtInput1.Text)
        DisplayQueue()
    End Sub
    Private Sub btnAdd2_Click() Handles btnAdd2.Click
        m_Queue.Enqueue(txtInput2.Text)
        DisplayQueue()
    End Sub
    Private Sub btnAdd3_Click() Handles btnAdd3.Click
        m_Queue.Enqueue(txtInput3.Text)
        DisplayQueue()
    End Sub

    ' Remove the first item from the queue.
    Private Sub btnDequeue_Click() Handles btnDequeue.Click
        Dim txt As String = DirectCast(m_Queue.Dequeue(), String)
        lstResult.Items.Add(txt)
        DisplayQueue()
    End Sub

    ' Display the items in the queue.
    Private Sub DisplayQueue()
        lstQueue.Items.Clear()
        For Each str As String In m_Queue.ToArray()
            lstQueue.Items.Add(str)
        Next str

        ' Enable or disable the Dequeue button.
        btnDequeue.Enabled = (m_Queue.Count > 0)
    End Sub
End Class
