﻿Public Class Form1
    Private Sub Form1_Load() Handles MyBase.Load
        Me.SetStyle(ControlStyles.AllPaintingInWmPaint Or ControlStyles.ResizeRedraw, True)
        Me.UpdateStyles()
    End Sub

    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        Dim txt As String = "Great Galloping Giraffes"
        Dim layout_rect As New RectangleF(0, 0, _
            Me.ClientSize.Width, Me.ClientSize.Height)
        e.Graphics.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAliasGridFit

        Using the_font As New Font("Times New Roman", 50, _
            FontStyle.Bold Or FontStyle.Italic, GraphicsUnit.Pixel)
            '    Using the_font As New Font("Times New Roman", 50, _
            '       FontStyle.Bold, GraphicsUnit.Pixel)

            Using string_format As New StringFormat
                string_format.LineAlignment = StringAlignment.Center
                string_format.Alignment = StringAlignment.Center

                ' Define an array of CharacterRange objects, 
                ' one for each character.
                Dim character_ranges(txt.Length - 1) As CharacterRange
                For i As Integer = 0 To txt.Length - 1
                    character_ranges(i) = New CharacterRange(i, 1)
                Next i

                ' Set the ranges in the StringFormat object.
                string_format.SetMeasurableCharacterRanges(character_ranges)

                ' Get the character range regions.
                Dim character_regions() As Region = _
                    e.Graphics.MeasureCharacterRanges(txt, _
                    the_font, layout_rect, string_format)

                ' Draw each region's bounds.
                For Each rgn As Region In character_regions
                    ' Convert the region into a Rectangle.
                    Dim character_bounds As RectangleF = rgn.GetBounds(e.Graphics)
                    Dim character_rect As Rectangle = _
                        Rectangle.Round(character_bounds)

                    ' Draw the bounds.
                    e.Graphics.DrawRectangle(Pens.Gray, character_rect)
                Next rgn

                ' Draw the text.
                e.Graphics.DrawString(txt, the_font, Brushes.Black, _
                    layout_rect, string_format)
            End Using ' string_format
        End Using ' the_font
    End Sub
End Class
