﻿Imports System.Resources
Imports System.Reflection

Public Class Form1
    Private Sub Form1_Load() Handles MyBase.Load
        ' Get the resource Assembly.
        Dim satellite_assembly As Assembly
        satellite_assembly = Assembly.LoadFrom("SatelliteResourcesDll.dll")

        ' Create a ResourceManager for the satellite's
        ' main resource file.
        Dim resource_manager As ResourceManager
        resource_manager = New ResourceManager( _
            "SatelliteResourcesDll.Resources", _
            satellite_assembly)

        ' Get the string resource from the satellite's
        ' main resource file.
        lblGreeting.Text = resource_manager.GetString("Greeting")

        ' Create a ResourceManager for the satellite's
        ' Images resource file.
        resource_manager = New ResourceManager( _
            "SatelliteResourcesDll.Images", _
            satellite_assembly)

        ' Get the form's background image from the satellite's
        ' Images resource file.
        Me.BackgroundImage = CType( _
            resource_manager.GetObject("Dog"), Image)
    End Sub
End Class
